// disco module code phaeno pinball
// controlls disco bubble, bumpers and flashgates
// runs on Arduino UNO
// with auto-calibration of distance sensors during setup

//INPUTS
#define IR_BUMP1 A5
#define IR_BUMP2 A4
#define IR_FOEN A3
#define IR_FLASH A2

//OUTPUTS
#define TOY 12 /*dancing toy*/
#define SPOTS 13
#define FOEN 8
#define DISCOBALL A1
#define BUMPER 1
#define FLASH A0
#define BUMP_LED1 9
#define BUMP_LED2 10
#define BUMP_LED3 11
#define SCORE 7
#define SPEAKER 6
#define IR_BUMP1_LED 2
#define IR_BUMP2_LED 3
#define IR_FOEN_LED 4
#define IR_FLASH_LED 5

   int noisereduce=4;   
   int ir_bump1=0;
   int ir_bump2=0;
   int ir_foen=0;
   int ir_flash=0;
   int ir_bump1_ref=0;
   int ir_bump2_ref=0;
   int ir_foen_ref=0;
   int ir_flash_ref=0;
   int threshold1=0;
   int threshold2=0;
   int threshold3=0;
   int threshold4=0;
   unsigned long foen_time;
   unsigned long bump_time;

 
void setup(){
  pinMode(TOY, OUTPUT);  
  pinMode(SPOTS, OUTPUT);  
  pinMode(FOEN, OUTPUT);  
  pinMode(DISCOBALL, OUTPUT);  
  pinMode(BUMPER, OUTPUT);  
  pinMode(FLASH, OUTPUT);  
  pinMode(BUMP_LED1, OUTPUT);  
  pinMode(BUMP_LED2, OUTPUT);  
  pinMode(BUMP_LED3, OUTPUT);  
  pinMode(SCORE, OUTPUT);  
  pinMode(SPEAKER, OUTPUT);  
  pinMode(IR_BUMP1_LED, OUTPUT);  
  pinMode(IR_BUMP2_LED, OUTPUT);  
  pinMode(IR_FOEN_LED, OUTPUT);  
  pinMode(IR_FLASH_LED, OUTPUT);  
  
    delay(500);


   // check IR sensors and find out reference values (do it twice and discard first reading as hickup)
    for (int j=0; j<2;j++){ 
       ir_bump1_ref=0;
       ir_bump2_ref=0;
       ir_foen_ref=0;
       ir_flash_ref=0;
       
       for (int i=0;i<noisereduce;i++){           // read adc's several times to reduce noise
         ir_bump1_ref += analogRead(IR_BUMP1);        // larger values=closer
         ir_bump2_ref += analogRead(IR_BUMP2);        // larger values=closer
         ir_foen_ref += analogRead(IR_FOEN);          // larger values=closer
         ir_flash_ref += analogRead(IR_FLASH);        // larger values=closer
       }
    }
    
    // check IR sensors to reference in multiple readings in order to set a threshold
    for (int j=0; j<100;j++){ 
       delay(10);
       ir_bump1=0;
       ir_bump2=0;
       ir_foen=0;
       ir_flash=0;
       
       for (int i=0;i<noisereduce;i++){           // read adc's several times to reduce noise
         ir_bump1 += analogRead(IR_BUMP1);        // larger values=closer
         ir_bump2 += analogRead(IR_BUMP2);        // larger values=closer
         ir_foen += analogRead(IR_FOEN);          // larger values=closer
         ir_flash += analogRead(IR_FLASH);        // larger values=closer
       }
       if (abs(ir_bump1-ir_bump1_ref)>threshold1)threshold1=abs(ir_bump1-ir_bump1_ref)+200; //sensitivity of IR sensor is adjusted with the added value -- larger value = less sensitive
       if (abs(ir_bump2-ir_bump2_ref)>threshold2)threshold2=abs(ir_bump2-ir_bump2_ref)+200; //sensitivity of IR sensor is adjusted with the added value -- larger value = less sensitive
       if (abs(ir_foen-ir_foen_ref)>threshold3)threshold3=abs(ir_foen-ir_foen_ref)+600;     //sensitivity of IR sensor is adjusted with the added value -- larger value = less sensitive
       if (abs(ir_flash-ir_flash_ref)>threshold4)threshold4=abs(ir_flash-ir_flash_ref)+400; //sensitivity of IR sensor is adjusted with the added value -- larger value = less sensitive
    }
   
   //beep      
   for (int i=0; i<50;i++){
        digitalWrite(SPEAKER,HIGH);
        delayMicroseconds(1000);
        digitalWrite(SPEAKER,LOW);
        delayMicroseconds(1000);
      }
      for (int i=0; i<100;i++){
        digitalWrite(SPEAKER,HIGH);
        delayMicroseconds(250);
        digitalWrite(SPEAKER,LOW);
        delayMicroseconds(250);
      }
}

void loop(){
  
  //soft blink Bumper
  unsigned long tref=millis()/7;

  int dim=isin(tref)/8+35;
  analogWrite(BUMP_LED1,dim);
  dim=isin(tref+120)/8+35;
  analogWrite(BUMP_LED2,dim);
  dim=isin(tref+240)/8+35;
  analogWrite(BUMP_LED3,dim);
  
 
   
   // check IR sensors 
   ir_bump1=0;
   ir_bump2=0;
   ir_foen=0;
   ir_flash=0;
   
   for (int i=0;i<noisereduce;i++){           // read adc's several times to reduce noise
     ir_bump1 += analogRead(IR_BUMP1);        // larger values=closer
     ir_bump2 += analogRead(IR_BUMP2);        // larger values=closer
     ir_foen += analogRead(IR_FOEN);          // larger values=closer
     ir_flash += analogRead(IR_FLASH);        // larger values=closer
   }
   

   
   //compare to reference in order to recognize ball
   
   boolean bump_hit=false;
   boolean foen_hit=false;
   boolean flash_hit=false;
   
   if (abs(ir_bump1-ir_bump1_ref)>threshold1){
     digitalWrite(IR_BUMP1_LED,HIGH);
     bump_hit=true;
   }else{
     digitalWrite(IR_BUMP1_LED,LOW);
   }
   
   if (abs(ir_bump2-ir_bump2_ref)>threshold2){
     digitalWrite(IR_BUMP2_LED,HIGH);
     bump_hit=true;
   }else{
     digitalWrite(IR_BUMP2_LED,LOW);
   }
   
   if (abs(ir_foen-ir_foen_ref)>threshold3){
     digitalWrite(IR_FOEN_LED,HIGH);
     foen_hit=true;
   }else{
     digitalWrite(IR_FOEN_LED,LOW);
   }
   
   if (abs(ir_flash-ir_flash_ref)>threshold4){
     digitalWrite(IR_FLASH_LED,HIGH);
     flash_hit=true;
   }else{
     digitalWrite(IR_FLASH_LED,LOW);
   }
   
   if (bump_hit && bump_time+4000<millis()){ //----------------------- Bumpers got hit!

     digitalWrite(SCORE,HIGH);
     digitalWrite(BUMPER,HIGH);
     for (int i=0;i<100;i++){                //duration of effect
       randomSeed(millis());
       tone(SPEAKER,random((100-i)*5+50,500+(100-i)*20));
       digitalWrite(BUMP_LED3,(i/3)%3);
       digitalWrite(BUMP_LED1,((i/3)+1)%3);
       digitalWrite(BUMP_LED2,((i/3)+2)%3);
       delay(20);
     }
      noTone(SPEAKER);
      digitalWrite(SCORE,LOW);
      digitalWrite(BUMPER,LOW);
      bump_time=millis();
    }
    
      
   if (flash_hit){ //----------------------- Flash got hit!
   
      digitalWrite(SCORE,HIGH);
      digitalWrite(FLASH,HIGH);
      for (int i=1; i<50;i++){
        delay((i/10)+1);
        digitalWrite(SPEAKER,HIGH);
        delay((20-(i/10)+1));
        digitalWrite(SPEAKER,LOW);
      }
      digitalWrite(SPEAKER,LOW);
      digitalWrite(SCORE,LOW);
      digitalWrite(FLASH,LOW);
    }
    
      
   if (foen_hit){ //----------------------- Foen got hit
     if (foen_time+1000<millis()){ //ball is trapped for 1 second
       digitalWrite(SCORE,HIGH);
       digitalWrite(DISCOBALL,HIGH);  
       digitalWrite(TOY,HIGH);
       for (int i=0;i<20;i++){
         digitalWrite(SPOTS,LOW);
         delay(190);
         digitalWrite(SPOTS,HIGH);
         delay(195);
       }
       digitalWrite(SCORE,LOW);
       digitalWrite(FOEN,HIGH);
       delay(1000);
       digitalWrite(SCORE,HIGH);
       delay(1500);
       digitalWrite(SCORE,LOW);
       digitalWrite(FOEN,LOW);   
       digitalWrite(SPOTS,LOW);  
       digitalWrite(DISCOBALL,LOW);  
       digitalWrite(TOY,LOW);
       digitalWrite(SPOTS,LOW);
       digitalWrite(SCORE,LOW);
     }
   }else{
     foen_time=millis();
   }
   
   
   

 


}


//////////////////////////////////



// 91 bytes 
uint8_t isinTable8[] = { 
  0, 4, 9, 13, 18, 22, 27, 31, 35, 40, 44, 
  49, 53, 57, 62, 66, 70, 75, 79, 83, 87, 
  91, 96, 100, 104, 108, 112, 116, 120, 124, 128, 

  131, 135, 139, 143, 146, 150, 153, 157, 160, 164, 
  167, 171, 174, 177, 180, 183, 186, 190, 192, 195, 
  198, 201, 204, 206, 209, 211, 214, 216, 219, 221, 

  223, 225, 227, 229, 231, 233, 235, 236, 238, 240, 
  241, 243, 244, 245, 246, 247, 248, 249, 250, 251, 
  252, 253, 253, 254, 254, 254, 255, 255, 255, 255, 
  }; 


int isin(long x) //fast sine function - slightly derivated from Rob Tillaart's fast sine function
{
  boolean pos = true;  // positive - keeps an eye on the sign.
  if (x >= 360) x %= 360;   
  if (x > 180) 
  {
    x -= 180;
    pos = !pos;
  }
  if (x > 90) x = 180 - x;
  if (pos) return isinTable8[x];
  return -isinTable8[x];
}


