// maincontroller code phaeno pinball
// runs on arduino mega 2560


//INPUTS:
#define I_PLUNGER 9
#define I_FLIPPER_L 12
#define I_FLIPPER_R 11
#define I_FLIPPER_O 10
#define I_LIGHTS_L 6
#define I_LIGHTS_R 5
#define SCORE A6
#define IR_PLUNGER A7

//OUTPUTS:
#define O_FLIPPER_L A0
#define O_FLIPPER_R A1
#define O_FLIPPER_O A2
#define O_PLUNGER A3
#define O_LIGHTS_L A4
#define O_LIGHTS_R A5
#define CALC_AC 14
#define CALC_0 15
#define CALC_1 16
#define CALC_5 17
#define CALC_PLUS 18
#define CALC_EQUALS 19
#define BELL 21
#define BUZZER 20
#define TIE_LIGHT A14
#define BONUS_LIGHT A15




 
void setup(){//====================================================================== SETUP
               


pinMode( I_PLUNGER   ,INPUT_PULLUP);
pinMode( I_FLIPPER_L ,INPUT_PULLUP);
pinMode( I_FLIPPER_R ,INPUT_PULLUP);
pinMode( I_FLIPPER_O ,INPUT_PULLUP);
pinMode( I_LIGHTS_L  ,INPUT_PULLUP);
pinMode( I_LIGHTS_R  ,INPUT_PULLUP);

pinMode( O_FLIPPER_L ,OUTPUT);
pinMode( O_FLIPPER_R ,OUTPUT);
pinMode( O_FLIPPER_O ,OUTPUT);
pinMode( O_PLUNGER   ,OUTPUT);
pinMode( O_LIGHTS_L  ,OUTPUT);
pinMode( O_LIGHTS_R  ,OUTPUT);
pinMode( CALC_AC     ,OUTPUT);
pinMode( CALC_0      ,OUTPUT);
pinMode( CALC_1      ,OUTPUT);
pinMode( CALC_5      ,OUTPUT);
pinMode( CALC_PLUS   ,OUTPUT);
pinMode( CALC_EQUALS ,OUTPUT);
pinMode( BELL        ,OUTPUT);
pinMode( BUZZER      ,OUTPUT);
pinMode( TIE_LIGHT   ,OUTPUT);
pinMode( BONUS_LIGHT ,OUTPUT);
  
  

//add_bonus(25);

//while(millis()<15000){take_it_easy_on();}
//take_it_easy_off();
/*
digitalWrite(O_PLUNGER,HIGH);
delay(6000);
digitalWrite(O_PLUNGER,LOW);

*/
Serial.begin(9600);

}

void loop(){//======================================================================= LOOP


int bonus=25;
int score=1000;

Serial.print(analogRead(IR_PLUNGER));
Serial.print("  ");
Serial.println(digitalRead(I_PLUNGER));





//............................................... check if ball is out (== in the plunger)
int verify=0;
if (analogRead(IR_PLUNGER)>230){                  // ir says out?
  while (analogRead(IR_PLUNGER)>230 && verify<100){delay(1);verify++;}//verify if this was not a false reading -> read sensor 100x
  if (verify==100){                               // ball *is* out!
  
  Serial.println("****** Ball is out! *******");
  add_bonus(bonus);                               // add bonus
  Serial.println("--- Waiting for Plunger ---");
  while (digitalRead(I_PLUNGER)){}                // wait until plunger button is pressed
  Serial.println("-N-E-W- - - - - -B-A-L-L-!-");
    new_ball();                                   // shoot the ball in!
    bonus=0;                                      // reset score & bonus
    score=0;
}
}

delay(100);


}



















//=================================================================================== FUNCTIONS

void new_ball(){//------------------------- initialize calculator , blow in new ball
  int d=75;
  digitalWrite(O_PLUNGER,HIGH);        // shoot in new ball (start hairdryer)
  digitalWrite(BELL,HIGH);
  digitalWrite(CALC_AC,HIGH);delay(d);          // switch on
  digitalWrite(BELL,LOW);
  digitalWrite(CALC_AC,LOW);delay(d);
  delay(4000);
  digitalWrite(CALC_1,HIGH);delay(d);           // enter 150
  digitalWrite(CALC_1,LOW);delay(d);
  digitalWrite(CALC_5,HIGH);delay(d);
  digitalWrite(CALC_5,LOW);delay(d);
  digitalWrite(CALC_0,HIGH);delay(d);
  digitalWrite(CALC_0,LOW);delay(d);
  digitalWrite(CALC_PLUS,HIGH);delay(d);        // +
  digitalWrite(CALC_PLUS,LOW);delay(d);
  digitalWrite(CALC_EQUALS,HIGH);delay(d);      // =
  digitalWrite(CALC_EQUALS,LOW);delay(d);
  digitalWrite(O_PLUNGER,LOW);                  // switch off plunger/hairdryer
}

void add_score(){//------------------------------- add score on calculator
  int d=75;
  digitalWrite(CALC_EQUALS,HIGH);delay(d);      // =
  digitalWrite(CALC_EQUALS,LOW);
}

void add_bonus(int bonus_score){//---------------- add bonus on calculator
  digitalWrite(BONUS_LIGHT,HIGH);
  int d=120;
  digitalWrite(CALC_PLUS,HIGH);delay(d);        // +
  digitalWrite(CALC_PLUS,LOW);delay(d);
  digitalWrite(CALC_1,HIGH);delay(d);           // enter 10
  digitalWrite(CALC_1,LOW);delay(d);
  digitalWrite(CALC_0,HIGH);delay(d);
  digitalWrite(CALC_0,LOW);delay(d);
  
  
  for (int i=0;i<bonus_score;i++){              //add ten points per bonus and ring bell
    digitalWrite(BONUS_LIGHT,HIGH);
    digitalWrite(CALC_EQUALS,HIGH);             // =
    digitalWrite(BELL,HIGH);
    delay(d/2);    
    digitalWrite(BELL,LOW);  
    delay(d/2); 
    digitalWrite(BELL,HIGH);
    digitalWrite(CALC_EQUALS,LOW);
    digitalWrite(BONUS_LIGHT,LOW);
    delay(d/2);    
    digitalWrite(BELL,LOW);  
    delay(d/2); 
  }
}

void take_it_easy_on(){                         //take it easy alarm ON
int t=millis()/500;
if (t%2){
    digitalWrite(TIE_LIGHT,HIGH);
    digitalWrite(BUZZER,HIGH);
  }else{
    digitalWrite(TIE_LIGHT,LOW);
    digitalWrite(BUZZER,LOW);
  }
}

void take_it_easy_off(){                         //take it easy alarm OFF
  digitalWrite(TIE_LIGHT,LOW);
  digitalWrite(BUZZER,LOW);
}
