// slingshot code phaeno pinball
// with auto-calibration of distance sensors during setup

#define TOY 8
#define FOENS 2
#define LEDS 5
#define STATUSLED1 13
#define STATUSLED2 12
#define IR1 0
#define IR2 1
#define POTI1 3
#define POTI2 2
#define SCORE 3

int ledpwm=10;
int toyreset=-60;
int toycount=toyreset;
int foencount=0;
int scorereset=-60;
int scorecount=scorereset;
int ref1=0;
int ref2=0;
int threshold=500;
int noisereduce=10;

 
void setup(){
pinMode(TOY, OUTPUT);
pinMode(FOENS, OUTPUT);
pinMode(LEDS, OUTPUT);
pinMode(STATUSLED1, OUTPUT);
pinMode(STATUSLED2, OUTPUT);
pinMode(SCORE,OUTPUT);
Serial.begin(9600);

//clear analog read hickups
delay(500);

   for (int i=0;i<noisereduce;i++){          // read adc's few times to reduce noise
     ref1 += analogRead(IR1);        // larger values=closer
   }
   for (int i=0;i<noisereduce;i++){          // read adc's few times to reduce noise
     ref2 += analogRead(IR2);        // larger values=closer
   }

//read distance values as reference   
   ref1=0;
   ref2=0;
   
 delay(500);
   for (int i=0;i<noisereduce;i++){          // read adc's 5x to reduce noise
     ref1 += analogRead(IR1);        // larger values=closer
   }
   for (int i=0;i<noisereduce;i++){          // read adc's 5x to reduce noise
     ref2 += analogRead(IR2);        // larger values=closer
   }
   
  Serial.print("ref1: "+ref1);
  Serial.println(" ref2: "+ref2);
  Serial.println("---------------------------");
}

void loop(){
  
   boolean hit=false;
   
   // check IR sensor 1
   int ir1=0;
   for (int i=0;i<noisereduce;i++){          // read adc's 5x to reduce noise
     ir1 += analogRead(IR1);        // larger values=closer
   }
   if (ir1>ref1+threshold){
     digitalWrite(STATUSLED1,HIGH);
     hit=true;
   }else{
     digitalWrite(STATUSLED1,LOW);
   }
   
   // check IR sensor 2
   int ir2=0;
   for (int i=0;i<noisereduce;i++){          // read adc's 5x to reduce noise
     ir2 += analogRead(IR2);        // larger values=closer
   }
   if (ir2>ref2+threshold){
     digitalWrite(STATUSLED2,HIGH);
     hit=true;
   }else{
     digitalWrite(STATUSLED2,LOW);
   }

     Serial.print("ir1: "+ir1);
     Serial.println(" ir2: "+ir2);
   
   // timing when ball hits the IR beams
   if (hit){
     ledpwm=255;
     if (toycount==toyreset){toycount=290;}else{if (toycount>0)toycount--;}
     if (scorecount==scorereset){scorecount=50;}else{if (scorecount>0)scorecount--;}
     foencount=130;
   }else{
     ledpwm=(ledpwm*20+1)/21;
     if (toycount>toyreset)toycount--;
     if (foencount)foencount--;
     if (scorecount>scorereset)scorecount--;
   }
 
   // switching of LED strip and TOY
   //-> blinky effect  if(ledpwm>1){if ((millis()/20)%3){analogWrite(LEDS,ledpwm);}else{analogWrite(LEDS,0);}}else{analogWrite(LEDS,ledpwm);}
     analogWrite(LEDS,ledpwm);
     if (toycount>0){digitalWrite(TOY,HIGH);}else{digitalWrite(TOY,LOW);}
     if (foencount){digitalWrite(FOENS,HIGH);}else{digitalWrite(FOENS,LOW);}
     if (scorecount>0){digitalWrite(SCORE,HIGH);}else{digitalWrite(SCORE,LOW);}

}
